/*------------------------------------------------------------------------------
 bin/djv_view/base.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "base.h"
#include <djv_ui/app.h>

namespace djv_view
{

void Color::lut_load()
{
  lut = image::Image();
  if (lut_file.get().size())
  {
    File file = lut_file;
    if (file.seq_valid()) file.type = file::SEQ;
    try
    {
      lut = *image::io::load(file)->get();
    }
    catch (Error error)
    {
      ui::app::global()->error(str::Format("%1: %2").
        arg(error).arg(File(lut_file).name()));
    }
  }
}

bool serialize(List<Str> * in, Color * out)
{
  if (! str::serialize(in, &out->name)) return false;
  Str tmp;
  if (! str::serialize(in, &tmp)) return false;
  out->lut_file = tmp;
  if (! image::gl::data::serialize(in, out)) return false;
  return true;
}

List<Str> serialize(const Color & in)
{
  return List<Str>() << str::serialize(in.name) <<
    str::serialize(in.lut_file) << image::gl::data::serialize(in);
}

const List<Str> & label_proxy()
{
  static const List<Str> data = List<Str>() << "0" << "1" << "2" << "3";
  return data;
}

}

