/*------------------------------------------------------------------------------
 bin/djv_view/image_info.h

 Image Information
 -----------------
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_VIEW_IMAGE_INFO_H
#define DJV_VIEW_IMAGE_INFO_H

#include <djv_ui/dialog.h>
#include "base.h"

namespace djv_view {
namespace image_info
{

//------------------------------------------------------------------------------
// Dialog

class Dialog : public ui::dialog::Base
{
public:
  
  Dialog();

  // Value.
  
  void set(const void *, const Str & file, const image::Image *);
  void update(const void *, const Str & file, const image::Image *);
  void del(const void *);
  
  // Widget.
  
  void show();
  
  // Layout.
  
  void update() { Base::update(); }

private:
  
  DJV_CALLBACK(Dialog, close_callback, bool);
  
  void widget_update();

  const void * _window;
  Str _file;
  image::Info _info;
  image::Tag _tag;
  bool _update;
  ui::text::Display * _file_widget, * _layer_widget, * _width_widget,
    * _height_widget, * _aspect_widget, * _pixel_widget;
  ui::text::Multiline_Display * _tag_widget;
};

//------------------------------------------------------------------------------
// Global

Dialog * dialog();

void del();

}
}

#endif

