/*------------------------------------------------------------------------------
 bin/djv_vlut/widget.h
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_VLUT_WIDGET_H
#define DJV_VLUT_WIDGET_H

#include "base.h"

namespace djv_vlut {
namespace widget
{

class Widget : public ui::widget::Widget
{
public:
  
  Widget();
  
  void set(const Color &);
  
  ui::Signal<const Color &> sig;
  
private:

  DJV_CALLBACK(Widget, lut_callback, const File &);
  DJV_CALLBACK(Widget, brightness_callback, double);
  DJV_CALLBACK(Widget, contrast_callback, double);
  DJV_CALLBACK(Widget, levels_in0_callback, double);
  DJV_CALLBACK(Widget, levels_in1_callback, double);
  DJV_CALLBACK(Widget, gamma_callback, double);
  DJV_CALLBACK(Widget, levels_out0_callback, double);
  DJV_CALLBACK(Widget, levels_out1_callback, double);
  DJV_CALLBACK(Widget, soft_clip_callback, double);

  void widget_update();
  
  Color _value;
  ui::file::Widget * _lut;
  ui::num::Float_Slider * _brightness, * _contrast;
  ui::num::Float_Slider * _levels_in [2], * _gamma, * _levels_out [2],
    * _soft_clip;
};

}
}

#endif

