/*------------------------------------------------------------------------------
 lib/djv_base/mem.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "mem.h"
#include <string.h>

namespace djv {
namespace mem
{

void copy(const void * in, void * out, size_t size)
{
  ::memcpy(out, in, size);
}

void set(uint8_t in, void * out, size_t size)
{
  ::memset(out, in, size);
}

void zero(void * out, size_t size)
{
  ::memset(out, 0, size);
}

int compare(const void * a, const void * b, size_t size)
{
  return ::memcmp(a, b, size);
}

const List<Str> & label_endian()
{
  static const List<Str> data = List<Str>() << "MSB" << "LSB";
  return data;
}

}
}

