/*------------------------------------------------------------------------------
 lib/djv_image/_gl_data.h

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "gl_data.h"

namespace djv {
namespace image {
namespace gl {
namespace data
{

class Data::_Texture
{
public:
  
  _Texture();
  ~_Texture();

  void draw(const image::Data &, const Box2i &, const Draw &,
    void * context_share) throw (Error);

private:

  FILTER _filter;
  bool _init;
  image::data::Info _info;
  GLuint _texture;
  Vec2i _texture_size;
};

class Data::_Fixed
{
public:
  
  void draw(const Draw &, void * context_share) throw (Error);
};

class Data::_Shader
{
public:
  
  _Shader();
  ~_Shader();

  void draw(const Draw &, void * context_share) throw (Error);

private:

  profile::PROFILE _profile;
  Display _display;
  CHANNEL _channel;
  bool _init;
  GLuint _lut_profile, _lut_display;
  GLhandleARB _shader, _program;
};

}
}
}
}
