/*------------------------------------------------------------------------------
 lib/djv_ui/gl.h
 
 OpenGL Widget
 -------------

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_GL_H
#define DJV_UI_GL_H

#include <djv_image/gl.h>
#include <djv_ui/widget.h>
#include <FL/Fl_Gl_Window.H>

namespace djv {
namespace ui {
namespace gl
{

//------------------------------------------------------------------------------
// Widget

class Widget : public Fl_Gl_Window, public widget::Base
{
public:

  Widget();
  virtual ~Widget() {}
  
  // Widget.
  
  virtual int handle(int);
  virtual void draw();
  
  // Layout.
  
  virtual void geom(const Box2i &);
  virtual void resize(int x, int y, int w, int h) { geom(Box2i(x, y, w, h)); }
  virtual const Box2i & geom() const { return widget::Base::geom(); }
  virtual int visible() const { return Fl_Gl_Window::visible(); }
};

}
}
}

#endif

