/*------------------------------------------------------------------------------
 lib/djv_ui/vec.h
 
 Vector Widgets
 --------------
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_VEC_H
#define DJV_UI_VEC_H

#include <djv_ui/widget.h>

namespace djv {
namespace ui {
namespace vec
{

//------------------------------------------------------------------------------
// Two-Dimensional Integer Vector Widget

class Vec2i : public widget::Widget
{
public:

  Vec2i();
  
  // Value.

  void set(const djv::Vec2i &);
  const djv::Vec2i & get() const { return _value; }
  Signal<const djv::Vec2i &> sig;
  
private:

  DJV_CALLBACK(Vec2i, widget_callback, int);
  DJV_CALLBACK(Vec2i, widget2_callback, int);
  
  void widget_update();

  djv::Vec2i _value, _tmp;
  num::Int_Edit * _widget, * _widget2;
};

//------------------------------------------------------------------------------
// Two-Dimensional Float Vector Widget

class Vec2f : public widget::Widget
{
public:

  Vec2f();
  
  // Value.

  void set(const djv::Vec2f &);
  const djv::Vec2f & get() const { return _value; }
  Signal<const djv::Vec2f &> sig;

private:

  DJV_CALLBACK(Vec2f, widget_callback, double);
  DJV_CALLBACK(Vec2f, widget2_callback, double);
  
  void widget_update();

  djv::Vec2f _value, _tmp;
  num::Float_Edit * _widget, * _widget2;
};

}
}
}

#endif

