/*------------------------------------------------------------------------------
 lib/djv_ui/widget.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG
#define _DBG "lib/djv_ui/widget.cxx"

#include "widget.h"
#include <djv_ui/style.h>
#include <FL/Fl.H>

namespace djv {
namespace ui {
namespace widget
{

Widget::Widget() : Fl_Group(0, 0, 0, 0), _visible(false)
{
  //DJV_DBG_OBJ2(_DBG, "Widget::Widget");

  Fl_Group::end();
  Fl_Group::box(FL_NO_BOX);
}

Widget::~Widget()
{
  //DJV_DBG_OBJ2(_DBG, "Widget::~Widget");
}

void Widget::tooltip(const Str & in)
{
  Base::tooltip(in);
  
  const int size = in.size() + 1;
  _tooltip_ascii.size(size);
  str::ascii(in, _tooltip_ascii(), size);
  Fl_Group::tooltip(_tooltip_ascii());
}

int Widget::handle(int in)
{
  switch (Base::handle(in))
  {
    case -1: return 0;
    case 1: return 1;
  }
  return Fl_Group::handle(in);
}

void Widget::draw()
{
  Fl_Group::draw();
  Base::draw();
}

void Widget::dirty()
{
  Base::dirty();

  labelfont(text_font());
  labelsize(style::global()->font_size());
  labelcolor(text_color());
  
  _visible = Fl_Group::visible() ? true : false;
}

void Widget::geom(const Box2i & in)
{
  Fl_Widget::resize(in.x, in.y, in.w, in.h);
  Base::geom(in);
}

}
}
}
