#define DJV_DBG

#include <djv_image/color.h>

using namespace djv;
using namespace djv::image;

const struct Str_Test {
  Str in;
  PIXEL pixel;
  Str out;
} str_test [] = {
  { "l u8 0", pixel::L_U8, "l u8 0" },
  { "l u8 255", pixel::L_U8, "l u8 255" },
  { "l u8 0", pixel::RGB_U10, "rgb u10 0 0 0" },
  { "l u8 255", pixel::RGB_U10, "rgb u10 1023 1023 1023" },
  { "l u8 0", pixel::L_U16, "l u16 0" },
  { "l u8 255", pixel::L_U16, "l u16 65535" },    
  { "l u16 0", pixel::L_U8, "l u8 0" },
  { "l u16 65535", pixel::L_U8, "l u8 255" },
  { "l u16 0", pixel::RGB_U10, "rgb u10 0 0 0" },
  { "l u16 65535", pixel::RGB_U10, "rgb u10 1023 1023 1023" },
  { "l u16 0", pixel::L_U16, "l u16 0" },
  { "l u16 65535", pixel::L_U16, "l u16 65535" },
  { "l f32 -1.0", pixel::L_U8, "l u8 0" },
  { "l f32 0.0", pixel::L_U8, "l u8 0" },
  { "l f32 0.5", pixel::L_U8, "l u8 128" },
  { "l f32 1.0", pixel::L_U8, "l u8 255" },
  { "l f32 2.0", pixel::L_U8, "l u8 255" },
  { "l f32 -1.0", pixel::L_U16, "l u16 0" },
  { "l f32 0.0", pixel::L_U16, "l u16 0" },
  { "l f32 0.5", pixel::L_U16, "l u16 32768" },
  { "l f32 1.0", pixel::L_U16, "l u16 65535" },
  { "l f32 2.0", pixel::L_U16, "l u16 65535" } };
const int str_test_size = sizeof(str_test) / sizeof(Str_Test);

int main(int argc, char ** argv)
{
  DJV_DBG_OBJ("color");
  
  for (int i = 0; i < str_test_size; ++i)
  {
    Color in;
    List<Str> tmp = str::split(str_test[i].in, " ");
    if (! color::serialize(&tmp, &in)) return 1;
    Color out(str_test[i].pixel);
    color::convert(in, &out);
    DJV_DBG_PRN("str: " << in << " = " << out);
    if (! str::compare(str::join(color::serialize(out), " "), str_test[i].out))
      return 1;
  }
  
  return 0;
}

