//#define DJV_DBG

#include <djv_ui/layout_row.h>
#include <djv_ui/button.h>
#include <djv_ui/window.h>
#include <djv_ui/app.h>

namespace
{
using namespace djv;

class App : public ui::App
{
public:

  App(int & argc, char ** argv);
  ~App();

private:

  DJV_CALLBACK(App, callback, bool) { print("button"); }
  DJV_CALLBACK(App, callback2, bool) { print("button 2"); }
  DJV_CALLBACK(App, exit_callback, bool) { exit(); }

  ui::window::Widget * _window;
};

App::App(int & argc, char ** argv) :
  ui::App("button", argc, argv),
  _window(0)
{
  DJV_DBG_OBJ("App::App");
  
  ui::button::Push * widget = new ui::button::Push("Button");
  ui::button::Push * widget2 = new ui::button::Push("Button 2");
  _window = new ui::window::Widget(name());

  ui::layout::Vertical * layout = new ui::layout::Vertical(_window);
  layout->add(widget);
  layout->add(widget2);
  
  _window->size(_window->size_hint());
  _window->show();

  widget->sig.set(this, callback);
  widget2->sig.set(this, callback2);
  _window->close_sig.set(this, exit_callback);

  valid(true);
}

App::~App()
{
  if (_window) _window->widget_del();
}

}

int main(int argc, char ** argv) { return ::App(argc, argv).exec(); }
